#!/usr/bin/python

from distutils.core import setup, Extension

bluezhci_module = Extension(       
	'bluezhci',
	libraries = ['bluetooth'],
        runtime_library_dirs = ['/usr/lib/'],
        sources = ['py_hci.c']
)

setup( 
	name = "bluezhci", 
	version = "1.0", 
	description = "Interface for hci functions", 
	maintainer = "Jose Cano Reyes", 
	maintainer_email = "jocare@inf.upv.es", 
	ext_modules = [ bluezhci_module ] 
)
