#!/usr/bin/python

from distutils.core import setup, Extension

module1 = Extension(       
	'bluezsocket',
        include_dirs = ['/usr/include/bluetooth'],
        libraries = ['bluetooth'],
        runtime_library_dirs = ['/usr/lib/'],
	sources = ['bluezsocket.c']
)

setup(
	name = "bluezsocket",
	version = "1.0",
	description = "L2CAP socket interface support for BlueZ",
	maintainer = 'Jose Cano Reyes',
	maintainer_email = 'jocare@inf.upv.es',
	ext_modules = [module1]
)



