#Boa:Frame:bluepeerFrame

from wxPython.wx import *
from wxPython.gizmos import *
from bluezhci import *
from bluezsocket import *

import bluepeerAbout
import thread
import time
import os


#**************************************************************************************************


def create(parent):
    return bluepeerFrame(parent)

[wxID_BLUEPEERFRAME, wxID_BLUEPEERFRAMEBMBSCAN, 
 wxID_BLUEPEERFRAMEBMPCONNECTION, wxID_BLUEPEERFRAMECMBTRANSFER, 
 wxID_BLUEPEERFRAMELBLCONECCTIONS, wxID_BLUEPEERFRAMELBLDEVICES, 
 wxID_BLUEPEERFRAMELBLFILES, wxID_BLUEPEERFRAMELBLLOCALADD, 
 wxID_BLUEPEERFRAMELBLLOCALADDV, wxID_BLUEPEERFRAMELBLLOCALCLAS, 
 wxID_BLUEPEERFRAMELBLLOCALCLASV, wxID_BLUEPEERFRAMELBLLOCALNAM, 
 wxID_BLUEPEERFRAMELBLLOCALNAMV, wxID_BLUEPEERFRAMELBLREMOTEADD, 
 wxID_BLUEPEERFRAMELBLREMOTEADDV, wxID_BLUEPEERFRAMELBLREMOTECLAS, 
 wxID_BLUEPEERFRAMELBLREMOTECLASV, wxID_BLUEPEERFRAMELBLREMOTENAM, 
 wxID_BLUEPEERFRAMELBLREMOTENAMV, wxID_BLUEPEERFRAMELBXCONECCTIONS, 
 wxID_BLUEPEERFRAMELBXDEVICES, wxID_BLUEPEERFRAMELBXFILES, 
 wxID_BLUEPEERFRAMEPNLCLIENT1, wxID_BLUEPEERFRAMESBMGRC, 
 wxID_BLUEPEERFRAMESPCCONTADOR, wxID_BLUEPEERFRAMESTATICBITMAP1, 
 wxID_BLUEPEERFRAMESTATICTEXT13, wxID_BLUEPEERFRAMESTBCLIENT, 
 wxID_BLUEPEERFRAMESTBLOCAL, wxID_BLUEPEERFRAMESTBREMOTE, 
 wxID_BLUEPEERFRAMESTLCLIENT1, 
] = map(lambda _init_ctrls: wxNewId(), range(31))


#**************************************************************************************************


[wxID_BLUEPEERFRAMEMNUHELPITEMS1] = map(lambda _init_coll_mnuHelp_Items: wxNewId(), range(1))

class bluepeerFrame(wxFrame):
    
    def _init_coll_mnuHelp_Items(self, parent):
        # generated method, don't edit

        parent.Append(helpString='General information',
              id=wxID_BLUEPEERFRAMEMNUHELPITEMS1, item='About',
              kind=wxITEM_NORMAL)
        EVT_MENU(self, wxID_BLUEPEERFRAMEMNUHELPITEMS1,
              self.OnMnuhelpitems0Menu)

    def _init_coll_mnbBluepeer_Menus(self, parent):
        # generated method, don't edit

        parent.Append(menu=self.mnuHelp, title='Help')

    def _init_coll_stbClient_Fields(self, parent):
        # generated method, don't edit
        parent.SetFieldsCount(2)

        parent.SetStatusText(i=0, text='Status')
        parent.SetStatusText(i=1, text='date')

        parent.SetStatusWidths([-7, -1])

    def _init_utils(self):
        # generated method, don't edit
        self.mnuHelp = wxMenu(title='')
        self._init_coll_mnuHelp_Items(self.mnuHelp)

        self.mnbBluepeer = wxMenuBar()

        self._init_coll_mnbBluepeer_Menus(self.mnbBluepeer)

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxFrame.__init__(self, id=wxID_BLUEPEERFRAME, name='bluepeerFrame',
              parent=prnt, pos=wxPoint(352, 224), size=wxSize(599, 412),
              style=wxMINIMIZE_BOX | wxSYSTEM_MENU | wxCAPTION,
              title='bluepeer 1.0')
        self._init_utils()
        self.SetClientSize(wxSize(591, 385))
        self.SetAutoLayout(False)
        self.Center(wxBOTH)
        self.SetMenuBar(self.mnbBluepeer)
        EVT_CLOSE(self, self.OnBluepeerframeClose)

        self.stbClient = wxStatusBar(id=wxID_BLUEPEERFRAMESTBCLIENT,
              name='stbClient', parent=self, style=0)
        self.stbClient.SetSize(wxSize(591, 20))
        self.stbClient.SetPosition(wxPoint(0, 351))
        self.stbClient.SetFieldsCount(2)
        self._init_coll_stbClient_Fields(self.stbClient)
        self.SetStatusBar(self.stbClient)

        self.pnlClient1 = wxPanel(id=wxID_BLUEPEERFRAMEPNLCLIENT1,
              name='pnlClient1', parent=self, pos=wxPoint(0, 0),
              size=wxSize(591, 346), style=wxTAB_TRAVERSAL)
        self.pnlClient1.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.sbmGrc = wxStaticBitmap(bitmap=wxBitmap('photos/GRC_logo2.jpg',
              wxBITMAP_TYPE_JPEG), id=wxID_BLUEPEERFRAMESBMGRC, name='sbmGrc',
              parent=self.pnlClient1, pos=wxPoint(456, 8), size=wxSize(117, 75),
              style=0)

        self.stlClient1 = wxStaticLine(id=wxID_BLUEPEERFRAMESTLCLIENT1,
              name='stlClient1', parent=self.pnlClient1, pos=wxPoint(10, 96),
              size=wxSize(574, 2), style=0)

        self.lblDevices = wxStaticText(id=wxID_BLUEPEERFRAMELBLDEVICES,
              label='Remote devices found', name='lblDevices',
              parent=self.pnlClient1, pos=wxPoint(200, 104), size=wxSize(135,
              16), style=0)
        self.lblDevices.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.bmbScan = wxBitmapButton(bitmap=wxBitmap('photos/rad1.gif',
              wxBITMAP_TYPE_GIF), id=wxID_BLUEPEERFRAMEBMBSCAN, name='bmbScan',
              parent=self.pnlClient1, pos=wxPoint(16, 8), size=wxSize(88, 72),
              style=wxBU_AUTODRAW, validator=wxDefaultValidator)
        self.bmbScan.SetToolTipString('Scan for devices')
        EVT_BUTTON(self.bmbScan, wxID_BLUEPEERFRAMEBMBSCAN,
              self.OnBmbscanButton)

        self.lbxDevices = wxListBox(choices=[], id=wxID_BLUEPEERFRAMELBXDEVICES,
              name='lbxDevices', parent=self.pnlClient1, pos=wxPoint(200, 128),
              size=wxSize(152, 96), style=0, validator=wxDefaultValidator)
        self.lbxDevices.SetBackgroundColour(wxColour(255, 255, 255))

        self.lbxFiles = wxListBox(choices=[], id=wxID_BLUEPEERFRAMELBXFILES,
              name='lbxFiles', parent=self.pnlClient1, pos=wxPoint(424, 128),
              size=wxSize(152, 168), style=0, validator=wxDefaultValidator)
        self.lbxFiles.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))
        self.lbxFiles.SetBackgroundColour(wxColour(255, 255, 255))

        self.lblFiles = wxStaticText(id=wxID_BLUEPEERFRAMELBLFILES,
              label='Available Files', name='lblFiles', parent=self.pnlClient1,
              pos=wxPoint(424, 104), size=wxSize(89, 16), style=0)
        self.lblFiles.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.cmbTransfer = wxButton(id=wxID_BLUEPEERFRAMECMBTRANSFER,
              label='Transfer', name='cmbTransfer', parent=self.pnlClient1,
              pos=wxPoint(445, 304), size=wxSize(112, 24), style=0)
        self.cmbTransfer.SetToolTipString('Transfer selected file')
        EVT_BUTTON(self.cmbTransfer, wxID_BLUEPEERFRAMECMBTRANSFER,
              self.OnCmbtransferButton)

        self.stbLocal = wxStaticBox(id=wxID_BLUEPEERFRAMESTBLOCAL,
              label='Local device', name='stbLocal', parent=self.pnlClient1,
              pos=wxPoint(16, 231), size=wxSize(168, 96), style=0)

        self.stbRemote = wxStaticBox(id=wxID_BLUEPEERFRAMESTBREMOTE,
              label='Remote device', name='stbRemote', parent=self.pnlClient1,
              pos=wxPoint(200, 231), size=wxSize(168, 96), style=0)

        self.lblLocalAdd = wxStaticText(id=wxID_BLUEPEERFRAMELBLLOCALADD,
              label='Address:', name='lblLocalAdd', parent=self.pnlClient1,
              pos=wxPoint(25, 256), size=wxSize(54, 16), style=0)
        self.lblLocalAdd.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))
        self.lblLocalAdd.Enable(True)

        self.lblLocalNam = wxStaticText(id=wxID_BLUEPEERFRAMELBLLOCALNAM,
              label='Name:', name='lblLocalNam', parent=self.pnlClient1,
              pos=wxPoint(25, 279), size=wxSize(40, 16), style=0)
        self.lblLocalNam.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.lblLocalClas = wxStaticText(id=wxID_BLUEPEERFRAMELBLLOCALCLAS,
              label='Type:', name='lblLocalClas', parent=self.pnlClient1,
              pos=wxPoint(25, 302), size=wxSize(35, 16), style=0)
        self.lblLocalClas.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.lblRemoteAdd = wxStaticText(id=wxID_BLUEPEERFRAMELBLREMOTEADD,
              label='Address:', name='lblRemoteAdd', parent=self.pnlClient1,
              pos=wxPoint(209, 256), size=wxSize(54, 16), style=0)
        self.lblRemoteAdd.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.lblRemoteNam = wxStaticText(id=wxID_BLUEPEERFRAMELBLREMOTENAM,
              label='Name:', name='lblRemoteNam', parent=self.pnlClient1,
              pos=wxPoint(209, 279), size=wxSize(40, 16), style=0)
        self.lblRemoteNam.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.lblRemoteClas = wxStaticText(id=wxID_BLUEPEERFRAMELBLREMOTECLAS,
              label='Type:', name='lblRemoteClas', parent=self.pnlClient1,
              pos=wxPoint(209, 302), size=wxSize(35, 16), style=0)
        self.lblRemoteClas.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL,
              False, 'MS Sans Serif'))

        self.lblLocalAddv = wxStaticText(id=wxID_BLUEPEERFRAMELBLLOCALADDV,
              label='n/a', name='lblLocalAddv', parent=self.pnlClient1,
              pos=wxPoint(86, 256), size=wxSize(19, 16), style=0)
        self.lblLocalAddv.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))

        self.lblLocalNamv = wxStaticText(id=wxID_BLUEPEERFRAMELBLLOCALNAMV,
              label='n/a', name='lblLocalNamv', parent=self.pnlClient1,
              pos=wxPoint(86, 279), size=wxSize(19, 16), style=0)

        self.lblLocalClasv = wxStaticText(id=wxID_BLUEPEERFRAMELBLLOCALCLASV,
              label='n/a', name='lblLocalClasv', parent=self.pnlClient1,
              pos=wxPoint(86, 302), size=wxSize(19, 16), style=0)

        self.lblRemoteAddv = wxStaticText(id=wxID_BLUEPEERFRAMELBLREMOTEADDV,
              label='n/a', name='lblRemoteAddv', parent=self.pnlClient1,
              pos=wxPoint(271, 256), size=wxSize(19, 16), style=0)

        self.lblRemoteNamv = wxStaticText(id=wxID_BLUEPEERFRAMELBLREMOTENAMV,
              label='n/a', name='lblRemoteNamv', parent=self.pnlClient1,
              pos=wxPoint(271, 279), size=wxSize(19, 16), style=0)

        self.lblRemoteClasv = wxStaticText(id=wxID_BLUEPEERFRAMELBLREMOTECLASV,
              label='n/a', name='lblRemoteClasv', parent=self.pnlClient1,
              pos=wxPoint(271, 302), size=wxSize(19, 16), style=0)

        self.staticText13 = wxStaticText(id=wxID_BLUEPEERFRAMESTATICTEXT13,
              label='Scan time', name='staticText13', parent=self.pnlClient1,
              pos=wxPoint(120, 24), size=wxSize(59, 16), style=0)

        self.spcContador = wxSpinCtrl(id=wxID_BLUEPEERFRAMESPCCONTADOR,
              initial=3, max=30, min=3, name='spcContador',
              parent=self.pnlClient1, pos=wxPoint(120, 48), size=wxSize(56, 32),
              style=wxSP_ARROW_KEYS)
        self.spcContador.SetValue(3)
        self.spcContador.SetFont(wxFont(14, wxSWISS, wxNORMAL, wxNORMAL, False,
              'MS Sans Serif'))
        self.spcContador.SetAutoLayout(False)
        self.spcContador.SetThemeEnabled(0)

        self.staticBitmap1 = wxStaticBitmap(bitmap=wxBitmap('photos/flecha.gif',
              wxBITMAP_TYPE_GIF), id=wxID_BLUEPEERFRAMESTATICBITMAP1,
              name='staticBitmap1', parent=self.pnlClient1, pos=wxPoint(384,
              240), size=wxSize(30, 18), style=0)

        self.bmpConnection = wxBitmapButton(bitmap=wxBitmap('photos/connect.gif',
              wxBITMAP_TYPE_GIF), id=wxID_BLUEPEERFRAMEBMPCONNECTION,
              name='bmpConnection', parent=self.pnlClient1, pos=wxPoint(200, 8),
              size=wxSize(88, 72), style=wxBU_AUTODRAW,
              validator=wxDefaultValidator)
        self.bmpConnection.SetToolTipString('Connect to selected remote device')
        EVT_BUTTON(self.bmpConnection, wxID_BLUEPEERFRAMEBMPCONNECTION,
              self.OnBmpconnectionButton)

        self.lbxConecctions = wxListBox(choices=[],
              id=wxID_BLUEPEERFRAMELBXCONECCTIONS, name='lbxConecctions',
              parent=self.pnlClient1, pos=wxPoint(16, 128), size=wxSize(152,
              96), style=0, validator=wxDefaultValidator)
        self.lbxConecctions.SetBackgroundColour(wxColour(255, 255, 255))

        self.lblConecctions = wxStaticText(id=wxID_BLUEPEERFRAMELBLCONECCTIONS,
              label='Incoming connections', name='lblConecctions',
              parent=self.pnlClient1, pos=wxPoint(16, 104), size=wxSize(129,
              16), style=0)
        self.lblConecctions.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL,
              False, 'MS Sans Serif'))

    def __init__(self, parent):
        self._init_ctrls(parent)
        
        self.loadIcon()
        self.setDate()        

        self.blue_sock = None       # var that represents de socket
        self.connected = False      # var that represents if client is connected with any server

        self.setLocalInformation()

        self.scanIncomingCon()        
        
    def loadIcon(self):
        '''Carga el icono de la aplicacion'''
        
        icon = wxIcon('photos/bt.ico',wxBITMAP_TYPE_ICO) # load applicaction icon
        self.SetIcon(icon)


    def setDate(self):
        '''Muestra la fecha actual en la barra de estado'''
        
        currentime = wxDateTime()        
        currentime.SetToCurrent()               
        self.stbClient.SetStatusText(i=1, text = str(currentime.GetDay()) + '/' +  str(currentime.GetMonth()) + '/' +  str(currentime.GetYear()) )


    def scanIncomingCon(self):
        '''Se lanza un nuevo thread para escanear conexiones entrantes'''

        thread.start_new_thread(self.startScan,tuple())

        return
    
    def startScan(self):
        '''escanea conexiones entrantes'''

        f = open('con.txt','w')
        f.write('')
        f.close()

        i=1

        while 1:

            try:
                time.sleep(3)

                if self.lbxConecctions.GetCount() == 0:
                    pass
                else:
                    self.lbxConecctions.Clear()

                f = open('con.txt','r')

                while 1:
                    data = f.readline()

                    if data == '':
                        break
                    else:
                        data2 = data[:-1]       
                        self.lbxConecctions.Append(data2)

                f.close()

            except:
                print "EXIT SCAN"
                return

            
    #**************************************************************************************************************        
        

    def setLocalInformation(self):
        '''Obtiene la informacion del dispositivo local'''

        dev_id = 0
        dd = open_dev( dev_id )   

        ba = local_device_ba(dev_id)
        s = read_local_name(dd)
        ty = local_device_type(dev_id)

        close_dev( dd )

        self.lblLocalAddv.SetLabel(ba)
        self.lblLocalNamv.SetLabel(s)
        self.lblLocalClasv.SetLabel(ty)


    def setRemoteInformation(self,remote_address,remote_type):
        '''Obtiene la informacion del dispositivo remoto'''

        address = remote_address
        type = remote_type

        dev_id = 0
        dd = open_dev( dev_id )   

        p = read_remote_name( dd, address )

        close_dev( dd )
        
        self.lblRemoteAddv.SetLabel(address)
        self.lblRemoteNamv.SetLabel(p)
        self.lblRemoteClasv.SetLabel(type)


    def recv_files_list(self):
        '''se recibe la lista de ficheros remotos disponibles'''

        while 1:
            data = self.blue_sock.recv(512)
            
            if data == "EMPTY":
                self.InformationMessage("Remote device has no files to download")
                self.connected = False
                self.blue_sock.close()
                
                return -1
            if data == "FIN":
                break
            
            self.lbxFiles.Append(data)


    def clear_remote_info(self):
        '''Borra la informacion del dispositivo remoto'''
        
        self.lbxFiles.Clear()
        self.lblRemoteAddv.SetLabel("n/a")
        self.lblRemoteNamv.SetLabel("n/a")
        self.lblRemoteClasv.SetLabel("n/a")

        self.stbClient.SetStatusText("Status")

                
    #**************************************************************************************************************       
    

    def OnBmbscanButton(self, event):
        
        self.stbClient.SetStatusText(i=0, text="Inquiring ... ")

        self.lbxDevices.Clear()
        
        scanTime = self.spcContador.GetValue() 
        
        dev_id = 0  
        num = 0
        (num, bdaddrs) = inquiry( dev_id, scanTime, 10 )
        
        if num == 0:
            self.InformationMessage("No remote devices detected. Retry later")
            self.stbClient.SetStatusText(i=0, text = 'Status')
            return

        for i in range( num ):
            self.lbxDevices.Append(bdaddrs[i])

        self.stbClient.SetStatusText(i=0, text = 'Status')
        
        event.Skip()
        
            
    def OnBmpconnectionButton(self, event):

        if self.connected:
            if self.remoteAddress == self.lbxDevices.GetStringSelection():
                self.InformationMessage("You are already connected to " + self.remoteAddress)
                return
            else:
                try:
                    self.blue_sock.send("SOCKET_CLOSED")
                    self.blue_sock.close()
                except:
                    pass

                self.connected = False
                self.clear_remote_info()
                

        self.remoteAddress = self.lbxDevices.GetStringSelection()

        if self.remoteAddress == "":
            self.WarningMessage("Select a remote device")
            return
        
        self.blue_sock = socket(PF_BLUETOOTH,SOCK_SEQPACKET,BTPROTO_L2CAP)
        res = self.blue_sock.connect_ex((self.remoteAddress,9))

        if res != 0:
            self.WarningMessage("Selected device is not available now, retry later")
            return

        self.connected = True

        while 1:                               # receive remote device type
            data = self.blue_sock.recv(256)
            
            if data == "END_TYPE":
                break
            self.remoteType = data

        if self.recv_files_list() == -1:
            return
        
        self.setRemoteInformation(self.remoteAddress,self.remoteType)        
        self.stbClient.SetStatusText(i=0, text = 'Connected to '+ self.remoteAddress)

        event.Skip()

    def OnCmbtransferButton(self, event):

        self.file = self.lbxFiles.GetStringSelection()

        if self.file == "":
            self.WarningMessage("No file is selected")
            return

        try:
            self.blue_sock.send(self.file)
        except:
            self.ErrorMessage("Remote device is down")
            self.clear_remote_info()
            self.connected = False
            return

        f = open('./data/incoming/' + self.file,'w')

        i = 0
    
        while 1:
            data = self.blue_sock.recv(512)
            if data == "FIN":
                i = i + 1
                break
            i = i + 1
            f.write(data)

        if i == 1:
            self.WarningMessage("No data received")
        else:
            self.InformationMessage("Data received")

        f.close()

        event.Skip()


    #**************************************************************************************************************


    def InformationMessage(self, msg):
        '''Muestra un mensaje de informacion'''
        
        dlg = wxMessageDialog(self, msg, "Information ...",wxOK | wxICON_INFORMATION)
        dlg.ShowModal()

    def WarningMessage(self, msg):
        '''Muestra un mensaje aviso'''
        
        dlg = wxMessageDialog(self, msg, "Warning ...",wxOK | wxICON_EXCLAMATION)
        dlg.ShowModal()

    def ErrorMessage(self, msg):
        '''Muestra un mensaje de error'''
        
        dlg = wxMessageDialog(self, msg, "Error ...",wxOK | wxICON_ERROR)
        dlg.ShowModal()


    #**************************************************************************************************************

    def OnMnuhelpitems0Menu(self, event):
        dlg = bluepeerAbout.dlgAbout(self)
        
        try:
            dlg.ShowModal()
        finally:
            dlg.Destroy()
        
        event.Skip()
        
    def OnBluepeerframeClose(self, event):
        '''Acciones a efectuar al cerrar la ventana'''

        if self.connected:
            try:
                bytes = self.blue_sock.send("SOCKET_CLOSED")
                self.blue_sock.close()
            except:
                pass
        
        event.Skip()

   

   
   


    

   

       




