#!/usr/bin/python

# An example program to test the python bluetooth module
# Copyright 2002 Fred Strauss
# <pybluetooth@strider.co.za>
#
# This program is distributed under the GNU LGPL
# See the LICENSE file or http://www.gnu.org/licenses/lgpl.txt for details

from bluetooth import *

dev_id = 0      # identificador del dispositivo

print "Scanning for devices ..."
(num, bdaddrs) = inquiry( dev_id, 8, 10 )     # asignacion multiple
print "Num responses:", num

dd = open_dev( dev_id )   # el valor de dd me lo devuelve el programa en C

if dd < 0:
	print "Error opening device"

else:
	for i in range( num ):
		print "%s -> %s" % ( bdaddrs[i], read_remote_name( dd, bdaddrs[i] ) )

	close_dev( dd )
